/* Protocol macros */

#ifndef _PS2_PROTOCOL_H_
#define _PS2_PROTOCOL_H_

#define BYTE(x) ((unsigned char)(x))

#define COMMAND_RESET                BYTE(0xFF)
#define COMMAND_RESEND               BYTE(0xFE)
#define COMMAND_SET_DEFAULTS         BYTE(0xF6)
#define COMMAND_DISABLE_REPORTING    BYTE(0xF5)
#define COMMAND_ENABLE_REPORTING     BYTE(0xF4)
#define COMMAND_SET_SAMPLE_RATE      BYTE(0xF3)
#define COMMAND_GET_DEVICE_ID        BYTE(0xF2)
#define COMMAND_GET_DEVICE_ID2       BYTE(0xE1)
#define COMMAND_SET_REMOTE_MODE      BYTE(0xF0)
#define COMMAND_SET_WRAP_MODE        BYTE(0xEE)
#define COMMAND_RESET_WRAP_MODE      BYTE(0xEC)
#define COMMAND_READ_DATA            BYTE(0xEB)
#define COMMAND_SET_STREAM_MODE      BYTE(0xEA)
#define COMMAND_STATUS_REQUEST       BYTE(0xE9)
#define COMMAND_SET_MOUSE_SCALING11  BYTE(0xE6)
#define COMMAND_SET_MOUSE_SCALING21  BYTE(0xE7)
#define COMMAND_SET_RESOLUTION       BYTE(0xE8)

#define RESPONSE_ACK                 BYTE(0xFA)
#define RESPONSE_ERROR               BYTE(0xFC)
#define RESPONSE_POST_OK             BYTE(0xAA)

#endif /* _PS2_PROTOCOL_H_ */
