#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <fcntl.h>
#include <sys/ioctl.h> #include <unistd.h> #include <err.h> #include <ctype.h>
#include <errno.h>
#include <usbhid.h>
#include <dev/usb/usb.h>
#include <dev/usb/usbhid.h>

static void printbits(char val) {
	int i;
	for (i = 7; i >= 0; i--) {
		printf("%d", (val >> i) & 1);
	}
	printf("\n");
}


int main(int argc, char **argv) {
	char devname[100], *dev = 0;
	int fd;
	struct usb_ctl_report_desc desc;
	report_desc_t r;
	char *data;
	int bytes;

	char syninfo[] = {
		0xE8, 0x00,
		0xE8, 0x00,
		0xE8, 0x00,
		0xE8, 0x00
	};

	char getstatus[] = {
		0xE9
	};


	dev = *(argv + 1);
	fd = open(dev, O_RDWR);
	if (fd == -1) {
		printf("Failed to open %s\n", dev);
		exit(1);
	}

	printf("ioctl: %d\n", 
	ioctl(fd, USB_GET_REPORT_DESC, &desc));

	printf("Size: %d\n", desc.ucrd_size);

	data = malloc(desc.ucrd_size);

	bytes = write(fd, syninfo, 8);
	printf("wrote %d\n", bytes);
	printf("Error: %s\n", strerror(errno));
	write(fd, getstatus, 2);
	printf("wrote %d\n", bytes);
	printf("Error: %s\n", strerror(errno));

	while (1) {
		printf("Attempting read\n");
		bytes = read(fd, data, 3);
		int x;
		printf("Got %d bytes\n", bytes);
		for (x = 0; x < bytes; x++) {
			printbits(data[x]);
		}
		printf("-\n");
	}

	close(fd);
	return 0;
}
